package de.uni_marburg.powersort.benchmark;

public class LongFormatter {
    /**
     * @param l Number to format.
     * @return Number as formatted String. Thousands are separated by underscore `_`.
     */
    public static String formatUnderscore(long l) {
        int firstDigitIdx = 0;
        // If l is negative, its string starts with '-'.
        // Thus, the first digit is at idx 1.
        if (l < 0) {
            firstDigitIdx = 1;
        }

        StringBuilder durFormatted = new StringBuilder();
        char[] digits = String.valueOf(l).toCharArray();
        int remainder = digits.length % 3;
        for (int i = 0; i < digits.length; i++) {
            boolean firstOrLastDigit = i <= firstDigitIdx || i == digits.length - 1;
            if (!firstOrLastDigit && i % 3 == remainder) {
                durFormatted.append('_');
            }
            durFormatted.append(digits[i]);
        }
        return durFormatted.toString();
    }

    /**
     * @param i Number to format.
     * @return Number as formatted String. Thousands are separated by underscore `_`.
     */
    public static String formatUnderscore(int i) {
        return formatUnderscore((long) i);
    }
}
