package de.uni_marburg.powersort.data;

import de.uni_marburg.powersort.JUnitUtil;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.converter.ConvertWith;
import org.junit.jupiter.params.provider.CsvSource;

import java.util.Arrays;

import static org.junit.jupiter.api.Assertions.*;

class AscendingRunsTest {
    @ParameterizedTest
    @CsvSource({
            "0,1,-1,''",
            "1,1,-1,0",
            "1,2,-2,0|1",
            "2,2,-2,0|1|-2|-1",
            "2,4,-2,0|1|2|3|-2|-1|0|1",
    })
    void testAscendingRuns1(int numOfRuns, int runLength, int decreaseBetweenRuns, @ConvertWith(JUnitUtil.IntArrayConverter.class) int[] expected) {
        Integer[] actualIntegers = AscendingRuns.newAscendingRuns(numOfRuns, runLength, decreaseBetweenRuns).getCopy();
        int[] actual = Arrays.stream(actualIntegers).mapToInt(Integer::valueOf).toArray();
        assertArrayEquals(expected, actual);
    }

    @ParameterizedTest
    @CsvSource({
            "1,0,-1",
            "-1,1,-1",
    })
    void testAscendingRuns2(int numOfRuns, int runLength, int decreaseBetweenRuns) {
        assertThrows(IllegalArgumentException.class, () -> AscendingRuns.newAscendingRuns(numOfRuns, runLength, decreaseBetweenRuns));
    }
}
